!
!   
real function Cheb(n,x) result(c)
integer, intent(in):: n
real, intent(in):: x
real a, b
integer i
!begin
  if(n==0) then
    c=1.0
  else if(n==1) then
    c=x
  else
    a=1.0; b=x
    do i=2,n
      c=2.0*x*b-a
      a=b; b=c
    end do
  end if
  return
end function Cheb
!
!   
real function Herm(n,x) result(c)
integer, intent(in):: n
real, intent(in):: x
real a, b
integer i
!begin
  if(n==0) then
    c=1.0
  else if(n==1) then
    c=2.0*x
  else
    a=1.0; b=2.0*x
    do i=1,n-1
      c=2.0*x*b-float(2*i)*a
      a=b; b=c
    end do
  end if
  return
end function Herm
!
!   
real function Lagr(n,x) result(c)
integer, intent(in):: n
real, intent(in):: x
real a, b
integer i
!begin
  if(n==0) then
    c=1.0
  else if(n==1) then
    c=1.0-x
  else
    a=1.0; b=1.0-x
    do i=1,n-1
      c=(float(1+i+i)-x)*b-float(i*i)*a
      a=b; b=c
    end do
  end if
  return
end function Lagr
!
!   
real function Lezh(n,x) result(c)
integer, intent(in):: n
real, intent(in):: x
real a, b
integer i
!begin
  if(n==0) then
    c=1.0
  else if(n==1) then
    c=x
  else
    a=1.0; b=x
    do i=2,n
      c=b*x+float(i-1)*(b*x-a)/float(i)
      a=b; b=c
    end do
  end if
  return
end function Lezh
